"""
@generated by mypy-protobuf.  Do not edit manually!
isort:skip_file
"""

import abc
import collections.abc
import grpc
import grpc.aio
import typing
import datasphere.yandex.cloud.priv.dataproc.v1.job_pb2
import datasphere.yandex.cloud.priv.dataproc.v1.job_service_pb2
import datasphere.yandex.cloud.priv.operation.operation_pb2

_T = typing.TypeVar("_T")

class _MaybeAsyncIterator(collections.abc.AsyncIterator[_T], collections.abc.Iterator[_T], metaclass=abc.ABCMeta): ...

class _ServicerContext(grpc.ServicerContext, grpc.aio.ServicerContext):  # type: ignore[misc, type-arg]
    ...

class JobServiceStub:
    """A set of methods for managing jobs for Dataproc cluster."""

    def __init__(self, channel: typing.Union[grpc.Channel, grpc.aio.Channel]) -> None: ...
    List: grpc.UnaryUnaryMultiCallable[
        yandex.cloud.priv.dataproc.v1.job_service_pb2.ListJobsRequest,
        yandex.cloud.priv.dataproc.v1.job_service_pb2.ListJobsResponse,
    ]
    """Retrieves a list of jobs for Dataproc cluster."""

    Create: grpc.UnaryUnaryMultiCallable[
        yandex.cloud.priv.dataproc.v1.job_service_pb2.CreateJobRequest,
        yandex.cloud.priv.operation.operation_pb2.Operation,
    ]
    """Creates a job for Dataproc cluster."""

    Get: grpc.UnaryUnaryMultiCallable[
        yandex.cloud.priv.dataproc.v1.job_service_pb2.GetJobRequest,
        yandex.cloud.priv.dataproc.v1.job_pb2.Job,
    ]
    """Returns the specified Dataproc job."""

    ListLog: grpc.UnaryUnaryMultiCallable[
        yandex.cloud.priv.dataproc.v1.job_service_pb2.ListJobLogRequest,
        yandex.cloud.priv.dataproc.v1.job_service_pb2.ListJobLogResponse,
    ]
    """Returns a log for Dataproc job."""

    UpdateStatus: grpc.UnaryUnaryMultiCallable[
        yandex.cloud.priv.dataproc.v1.job_service_pb2.UpdateJobStatusRequest,
        yandex.cloud.priv.dataproc.v1.job_service_pb2.UpdateJobStatusResponse,
    ]
    """Updates Dataproc job status."""

    GetInternalList: grpc.UnaryUnaryMultiCallable[
        yandex.cloud.priv.dataproc.v1.job_service_pb2.InternalListJobsRequest,
        yandex.cloud.priv.dataproc.v1.job_service_pb2.ListJobsResponse,
    ]
    """Private method for listing all jobs on dataproc-manager.
    Retrieves a list of jobs for all clusters.
    """

    Cancel: grpc.UnaryUnaryMultiCallable[
        yandex.cloud.priv.dataproc.v1.job_service_pb2.CancelJobRequest,
        yandex.cloud.priv.operation.operation_pb2.Operation,
    ]
    """Cancels the specified Dataproc job."""

    CreateSupport: grpc.UnaryUnaryMultiCallable[
        yandex.cloud.priv.dataproc.v1.job_service_pb2.CreateSupportRequest,
        yandex.cloud.priv.dataproc.v1.job_service_pb2.CreateSupportResponse,
    ]
    """Creates a support job for Dataproc cluster."""

    GetSupport: grpc.UnaryUnaryMultiCallable[
        yandex.cloud.priv.dataproc.v1.job_service_pb2.GetJobRequest,
        yandex.cloud.priv.dataproc.v1.job_pb2.SupportJob,
    ]
    """Returns the specified support job."""

    ListSupport: grpc.UnaryUnaryMultiCallable[
        yandex.cloud.priv.dataproc.v1.job_service_pb2.ListJobsRequest,
        yandex.cloud.priv.dataproc.v1.job_service_pb2.ListSupportResponse,
    ]
    """Retrieves a list of support jobs for Dataproc cluster."""

    UpdateSupportStatus: grpc.UnaryUnaryMultiCallable[
        yandex.cloud.priv.dataproc.v1.job_service_pb2.UpdateSupportStatusRequest,
        yandex.cloud.priv.dataproc.v1.job_service_pb2.UpdateJobStatusResponse,
    ]
    """Updates Dataproc support job status."""

    ListLogSupport: grpc.UnaryUnaryMultiCallable[
        yandex.cloud.priv.dataproc.v1.job_service_pb2.ListJobLogRequest,
        yandex.cloud.priv.dataproc.v1.job_service_pb2.ListJobLogResponse,
    ]
    """Returns support job log."""

class JobServiceAsyncStub:
    """A set of methods for managing jobs for Dataproc cluster."""

    List: grpc.aio.UnaryUnaryMultiCallable[
        yandex.cloud.priv.dataproc.v1.job_service_pb2.ListJobsRequest,
        yandex.cloud.priv.dataproc.v1.job_service_pb2.ListJobsResponse,
    ]
    """Retrieves a list of jobs for Dataproc cluster."""

    Create: grpc.aio.UnaryUnaryMultiCallable[
        yandex.cloud.priv.dataproc.v1.job_service_pb2.CreateJobRequest,
        yandex.cloud.priv.operation.operation_pb2.Operation,
    ]
    """Creates a job for Dataproc cluster."""

    Get: grpc.aio.UnaryUnaryMultiCallable[
        yandex.cloud.priv.dataproc.v1.job_service_pb2.GetJobRequest,
        yandex.cloud.priv.dataproc.v1.job_pb2.Job,
    ]
    """Returns the specified Dataproc job."""

    ListLog: grpc.aio.UnaryUnaryMultiCallable[
        yandex.cloud.priv.dataproc.v1.job_service_pb2.ListJobLogRequest,
        yandex.cloud.priv.dataproc.v1.job_service_pb2.ListJobLogResponse,
    ]
    """Returns a log for Dataproc job."""

    UpdateStatus: grpc.aio.UnaryUnaryMultiCallable[
        yandex.cloud.priv.dataproc.v1.job_service_pb2.UpdateJobStatusRequest,
        yandex.cloud.priv.dataproc.v1.job_service_pb2.UpdateJobStatusResponse,
    ]
    """Updates Dataproc job status."""

    GetInternalList: grpc.aio.UnaryUnaryMultiCallable[
        yandex.cloud.priv.dataproc.v1.job_service_pb2.InternalListJobsRequest,
        yandex.cloud.priv.dataproc.v1.job_service_pb2.ListJobsResponse,
    ]
    """Private method for listing all jobs on dataproc-manager.
    Retrieves a list of jobs for all clusters.
    """

    Cancel: grpc.aio.UnaryUnaryMultiCallable[
        yandex.cloud.priv.dataproc.v1.job_service_pb2.CancelJobRequest,
        yandex.cloud.priv.operation.operation_pb2.Operation,
    ]
    """Cancels the specified Dataproc job."""

    CreateSupport: grpc.aio.UnaryUnaryMultiCallable[
        yandex.cloud.priv.dataproc.v1.job_service_pb2.CreateSupportRequest,
        yandex.cloud.priv.dataproc.v1.job_service_pb2.CreateSupportResponse,
    ]
    """Creates a support job for Dataproc cluster."""

    GetSupport: grpc.aio.UnaryUnaryMultiCallable[
        yandex.cloud.priv.dataproc.v1.job_service_pb2.GetJobRequest,
        yandex.cloud.priv.dataproc.v1.job_pb2.SupportJob,
    ]
    """Returns the specified support job."""

    ListSupport: grpc.aio.UnaryUnaryMultiCallable[
        yandex.cloud.priv.dataproc.v1.job_service_pb2.ListJobsRequest,
        yandex.cloud.priv.dataproc.v1.job_service_pb2.ListSupportResponse,
    ]
    """Retrieves a list of support jobs for Dataproc cluster."""

    UpdateSupportStatus: grpc.aio.UnaryUnaryMultiCallable[
        yandex.cloud.priv.dataproc.v1.job_service_pb2.UpdateSupportStatusRequest,
        yandex.cloud.priv.dataproc.v1.job_service_pb2.UpdateJobStatusResponse,
    ]
    """Updates Dataproc support job status."""

    ListLogSupport: grpc.aio.UnaryUnaryMultiCallable[
        yandex.cloud.priv.dataproc.v1.job_service_pb2.ListJobLogRequest,
        yandex.cloud.priv.dataproc.v1.job_service_pb2.ListJobLogResponse,
    ]
    """Returns support job log."""

class JobServiceServicer(metaclass=abc.ABCMeta):
    """A set of methods for managing jobs for Dataproc cluster."""

    @abc.abstractmethod
    def List(
        self,
        request: yandex.cloud.priv.dataproc.v1.job_service_pb2.ListJobsRequest,
        context: _ServicerContext,
    ) -> typing.Union[yandex.cloud.priv.dataproc.v1.job_service_pb2.ListJobsResponse, collections.abc.Awaitable[yandex.cloud.priv.dataproc.v1.job_service_pb2.ListJobsResponse]]:
        """Retrieves a list of jobs for Dataproc cluster."""

    @abc.abstractmethod
    def Create(
        self,
        request: yandex.cloud.priv.dataproc.v1.job_service_pb2.CreateJobRequest,
        context: _ServicerContext,
    ) -> typing.Union[yandex.cloud.priv.operation.operation_pb2.Operation, collections.abc.Awaitable[yandex.cloud.priv.operation.operation_pb2.Operation]]:
        """Creates a job for Dataproc cluster."""

    @abc.abstractmethod
    def Get(
        self,
        request: yandex.cloud.priv.dataproc.v1.job_service_pb2.GetJobRequest,
        context: _ServicerContext,
    ) -> typing.Union[yandex.cloud.priv.dataproc.v1.job_pb2.Job, collections.abc.Awaitable[yandex.cloud.priv.dataproc.v1.job_pb2.Job]]:
        """Returns the specified Dataproc job."""

    @abc.abstractmethod
    def ListLog(
        self,
        request: yandex.cloud.priv.dataproc.v1.job_service_pb2.ListJobLogRequest,
        context: _ServicerContext,
    ) -> typing.Union[yandex.cloud.priv.dataproc.v1.job_service_pb2.ListJobLogResponse, collections.abc.Awaitable[yandex.cloud.priv.dataproc.v1.job_service_pb2.ListJobLogResponse]]:
        """Returns a log for Dataproc job."""

    @abc.abstractmethod
    def UpdateStatus(
        self,
        request: yandex.cloud.priv.dataproc.v1.job_service_pb2.UpdateJobStatusRequest,
        context: _ServicerContext,
    ) -> typing.Union[yandex.cloud.priv.dataproc.v1.job_service_pb2.UpdateJobStatusResponse, collections.abc.Awaitable[yandex.cloud.priv.dataproc.v1.job_service_pb2.UpdateJobStatusResponse]]:
        """Updates Dataproc job status."""

    @abc.abstractmethod
    def GetInternalList(
        self,
        request: yandex.cloud.priv.dataproc.v1.job_service_pb2.InternalListJobsRequest,
        context: _ServicerContext,
    ) -> typing.Union[yandex.cloud.priv.dataproc.v1.job_service_pb2.ListJobsResponse, collections.abc.Awaitable[yandex.cloud.priv.dataproc.v1.job_service_pb2.ListJobsResponse]]:
        """Private method for listing all jobs on dataproc-manager.
        Retrieves a list of jobs for all clusters.
        """

    @abc.abstractmethod
    def Cancel(
        self,
        request: yandex.cloud.priv.dataproc.v1.job_service_pb2.CancelJobRequest,
        context: _ServicerContext,
    ) -> typing.Union[yandex.cloud.priv.operation.operation_pb2.Operation, collections.abc.Awaitable[yandex.cloud.priv.operation.operation_pb2.Operation]]:
        """Cancels the specified Dataproc job."""

    @abc.abstractmethod
    def CreateSupport(
        self,
        request: yandex.cloud.priv.dataproc.v1.job_service_pb2.CreateSupportRequest,
        context: _ServicerContext,
    ) -> typing.Union[yandex.cloud.priv.dataproc.v1.job_service_pb2.CreateSupportResponse, collections.abc.Awaitable[yandex.cloud.priv.dataproc.v1.job_service_pb2.CreateSupportResponse]]:
        """Creates a support job for Dataproc cluster."""

    @abc.abstractmethod
    def GetSupport(
        self,
        request: yandex.cloud.priv.dataproc.v1.job_service_pb2.GetJobRequest,
        context: _ServicerContext,
    ) -> typing.Union[yandex.cloud.priv.dataproc.v1.job_pb2.SupportJob, collections.abc.Awaitable[yandex.cloud.priv.dataproc.v1.job_pb2.SupportJob]]:
        """Returns the specified support job."""

    @abc.abstractmethod
    def ListSupport(
        self,
        request: yandex.cloud.priv.dataproc.v1.job_service_pb2.ListJobsRequest,
        context: _ServicerContext,
    ) -> typing.Union[yandex.cloud.priv.dataproc.v1.job_service_pb2.ListSupportResponse, collections.abc.Awaitable[yandex.cloud.priv.dataproc.v1.job_service_pb2.ListSupportResponse]]:
        """Retrieves a list of support jobs for Dataproc cluster."""

    @abc.abstractmethod
    def UpdateSupportStatus(
        self,
        request: yandex.cloud.priv.dataproc.v1.job_service_pb2.UpdateSupportStatusRequest,
        context: _ServicerContext,
    ) -> typing.Union[yandex.cloud.priv.dataproc.v1.job_service_pb2.UpdateJobStatusResponse, collections.abc.Awaitable[yandex.cloud.priv.dataproc.v1.job_service_pb2.UpdateJobStatusResponse]]:
        """Updates Dataproc support job status."""

    @abc.abstractmethod
    def ListLogSupport(
        self,
        request: yandex.cloud.priv.dataproc.v1.job_service_pb2.ListJobLogRequest,
        context: _ServicerContext,
    ) -> typing.Union[yandex.cloud.priv.dataproc.v1.job_service_pb2.ListJobLogResponse, collections.abc.Awaitable[yandex.cloud.priv.dataproc.v1.job_service_pb2.ListJobLogResponse]]:
        """Returns support job log."""

def add_JobServiceServicer_to_server(servicer: JobServiceServicer, server: typing.Union[grpc.Server, grpc.aio.Server]) -> None: ...
