"""
@generated by mypy-protobuf.  Do not edit manually!
isort:skip_file
"""

import abc
import collections.abc
import google.protobuf.empty_pb2
import grpc
import grpc.aio
import typing
import datasphere.yandex.cloud.priv.iam.v1.mfa.console.totp_profile_service_pb2

_T = typing.TypeVar("_T")

class _MaybeAsyncIterator(collections.abc.AsyncIterator[_T], collections.abc.Iterator[_T], metaclass=abc.ABCMeta): ...

class _ServicerContext(grpc.ServicerContext, grpc.aio.ServicerContext):  # type: ignore[misc, type-arg]
    ...

class TotpProfileServiceStub:
    """A set of methods for managing hardware and software time-based one time passwords (TOTP).
    The user credentials should be passed in the authorization header.
    """

    def __init__(self, channel: typing.Union[grpc.Channel, grpc.aio.Channel]) -> None: ...
    Verify: grpc.UnaryUnaryMultiCallable[
        yandex.cloud.priv.iam.v1.mfa.console.totp_profile_service_pb2.VerifyTotpRequest,
        yandex.cloud.priv.iam.v1.mfa.console.totp_profile_service_pb2.VerifyTotpResponse,
    ]
    """Verifies user-supplied TOTP value. See https://tools.ietf.org/html/rfc6238#section-5.2 for the reference."""

    List: grpc.UnaryUnaryMultiCallable[
        google.protobuf.empty_pb2.Empty,
        yandex.cloud.priv.iam.v1.mfa.console.totp_profile_service_pb2.ListTotpResponse,
    ]
    """Retrieves the list of TOTP-profiles and required MFA-policies for authenticated user"""

class TotpProfileServiceAsyncStub:
    """A set of methods for managing hardware and software time-based one time passwords (TOTP).
    The user credentials should be passed in the authorization header.
    """

    Verify: grpc.aio.UnaryUnaryMultiCallable[
        yandex.cloud.priv.iam.v1.mfa.console.totp_profile_service_pb2.VerifyTotpRequest,
        yandex.cloud.priv.iam.v1.mfa.console.totp_profile_service_pb2.VerifyTotpResponse,
    ]
    """Verifies user-supplied TOTP value. See https://tools.ietf.org/html/rfc6238#section-5.2 for the reference."""

    List: grpc.aio.UnaryUnaryMultiCallable[
        google.protobuf.empty_pb2.Empty,
        yandex.cloud.priv.iam.v1.mfa.console.totp_profile_service_pb2.ListTotpResponse,
    ]
    """Retrieves the list of TOTP-profiles and required MFA-policies for authenticated user"""

class TotpProfileServiceServicer(metaclass=abc.ABCMeta):
    """A set of methods for managing hardware and software time-based one time passwords (TOTP).
    The user credentials should be passed in the authorization header.
    """

    @abc.abstractmethod
    def Verify(
        self,
        request: yandex.cloud.priv.iam.v1.mfa.console.totp_profile_service_pb2.VerifyTotpRequest,
        context: _ServicerContext,
    ) -> typing.Union[yandex.cloud.priv.iam.v1.mfa.console.totp_profile_service_pb2.VerifyTotpResponse, collections.abc.Awaitable[yandex.cloud.priv.iam.v1.mfa.console.totp_profile_service_pb2.VerifyTotpResponse]]:
        """Verifies user-supplied TOTP value. See https://tools.ietf.org/html/rfc6238#section-5.2 for the reference."""

    @abc.abstractmethod
    def List(
        self,
        request: google.protobuf.empty_pb2.Empty,
        context: _ServicerContext,
    ) -> typing.Union[yandex.cloud.priv.iam.v1.mfa.console.totp_profile_service_pb2.ListTotpResponse, collections.abc.Awaitable[yandex.cloud.priv.iam.v1.mfa.console.totp_profile_service_pb2.ListTotpResponse]]:
        """Retrieves the list of TOTP-profiles and required MFA-policies for authenticated user"""

def add_TotpProfileServiceServicer_to_server(servicer: TotpProfileServiceServicer, server: typing.Union[grpc.Server, grpc.aio.Server]) -> None: ...
