"""
@generated by mypy-protobuf.  Do not edit manually!
isort:skip_file
"""

import builtins
import google.protobuf.descriptor
import google.protobuf.duration_pb2
import google.protobuf.internal.enum_type_wrapper
import google.protobuf.message
import google.protobuf.timestamp_pb2
import sys
import typing

if sys.version_info >= (3, 10):
    import typing as typing_extensions
else:
    import typing_extensions

DESCRIPTOR: google.protobuf.descriptor.FileDescriptor

class _VerificationResult:
    ValueType = typing.NewType("ValueType", builtins.int)
    V: typing_extensions.TypeAlias = ValueType

class _VerificationResultEnumTypeWrapper(google.protobuf.internal.enum_type_wrapper._EnumTypeWrapper[_VerificationResult.ValueType], builtins.type):
    DESCRIPTOR: google.protobuf.descriptor.EnumDescriptor
    VERIFICATION_RESULT_UNSPECIFIED: _VerificationResult.ValueType  # 0
    OK: _VerificationResult.ValueType  # 1
    """The verification succeeded."""
    CODE_MISMATCH: _VerificationResult.ValueType  # 2
    """The TOTP code sent by the client does not match the code generated on the server side."""
    CODE_REUSE: _VerificationResult.ValueType  # 3
    """The TOTP code has been used already (possibly a reuse attack)."""
    TOO_MANY_REQUESTS: _VerificationResult.ValueType  # 4
    """Blocked due to brute force."""
    NOT_SET: _VerificationResult.ValueType  # 5
    """No TOTP configured for this user."""
    NEED_MORE_CODES: _VerificationResult.ValueType  # 6
    """The verification succeeded, but item >= inner window size (and item < outer window size)."""

class VerificationResult(_VerificationResult, metaclass=_VerificationResultEnumTypeWrapper): ...

VERIFICATION_RESULT_UNSPECIFIED: VerificationResult.ValueType  # 0
OK: VerificationResult.ValueType  # 1
"""The verification succeeded."""
CODE_MISMATCH: VerificationResult.ValueType  # 2
"""The TOTP code sent by the client does not match the code generated on the server side."""
CODE_REUSE: VerificationResult.ValueType  # 3
"""The TOTP code has been used already (possibly a reuse attack)."""
TOO_MANY_REQUESTS: VerificationResult.ValueType  # 4
"""Blocked due to brute force."""
NOT_SET: VerificationResult.ValueType  # 5
"""No TOTP configured for this user."""
NEED_MORE_CODES: VerificationResult.ValueType  # 6
"""The verification succeeded, but item >= inner window size (and item < outer window size)."""
global___VerificationResult = VerificationResult

class _HashAlgorithm:
    ValueType = typing.NewType("ValueType", builtins.int)
    V: typing_extensions.TypeAlias = ValueType

class _HashAlgorithmEnumTypeWrapper(google.protobuf.internal.enum_type_wrapper._EnumTypeWrapper[_HashAlgorithm.ValueType], builtins.type):
    DESCRIPTOR: google.protobuf.descriptor.EnumDescriptor
    HASH_ALGORITHM_UNSPECIFIED: _HashAlgorithm.ValueType  # 0
    SHA1: _HashAlgorithm.ValueType  # 1
    SHA256: _HashAlgorithm.ValueType  # 2
    SHA512: _HashAlgorithm.ValueType  # 3

class HashAlgorithm(_HashAlgorithm, metaclass=_HashAlgorithmEnumTypeWrapper):
    """Default is SHA1."""

HASH_ALGORITHM_UNSPECIFIED: HashAlgorithm.ValueType  # 0
SHA1: HashAlgorithm.ValueType  # 1
SHA256: HashAlgorithm.ValueType  # 2
SHA512: HashAlgorithm.ValueType  # 3
global___HashAlgorithm = HashAlgorithm

@typing.final
class TotpProfile(google.protobuf.message.Message):
    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    ID_FIELD_NUMBER: builtins.int
    SUBJECT_ID_FIELD_NUMBER: builtins.int
    ALGORITHM_FIELD_NUMBER: builtins.int
    DIGITS_FIELD_NUMBER: builtins.int
    CREATED_AT_FIELD_NUMBER: builtins.int
    OPTIONS_FIELD_NUMBER: builtins.int
    ACTIVE_FIELD_NUMBER: builtins.int
    id: builtins.str
    """TOTP profile ID."""
    subject_id: builtins.str
    """The user that this password belongs to."""
    algorithm: global___HashAlgorithm.ValueType
    """The algorithm used to calculate the hash."""
    digits: builtins.int
    """The length of the TOTP code (6-8)."""
    active: builtins.bool
    """True, if the user has ever been successfully verified."""
    @property
    def created_at(self) -> google.protobuf.timestamp_pb2.Timestamp: ...
    @property
    def options(self) -> global___TotpProfileOptions:
        """Additional TOTP parameters."""

    def __init__(
        self,
        *,
        id: builtins.str = ...,
        subject_id: builtins.str = ...,
        algorithm: global___HashAlgorithm.ValueType = ...,
        digits: builtins.int = ...,
        created_at: google.protobuf.timestamp_pb2.Timestamp | None = ...,
        options: global___TotpProfileOptions | None = ...,
        active: builtins.bool = ...,
    ) -> None: ...
    def HasField(self, field_name: typing.Literal["created_at", b"created_at", "options", b"options"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing.Literal["active", b"active", "algorithm", b"algorithm", "created_at", b"created_at", "digits", b"digits", "id", b"id", "options", b"options", "subject_id", b"subject_id"]) -> None: ...

global___TotpProfile = TotpProfile

@typing.final
class TotpProfileOptions(google.protobuf.message.Message):
    """Additional TOTP parameters."""

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    TIME_STEP_FIELD_NUMBER: builtins.int
    @property
    def time_step(self) -> google.protobuf.duration_pb2.Duration:
        """The period that a TOTP code will be valid for."""

    def __init__(
        self,
        *,
        time_step: google.protobuf.duration_pb2.Duration | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing.Literal["time_step", b"time_step"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing.Literal["time_step", b"time_step"]) -> None: ...

global___TotpProfileOptions = TotpProfileOptions
