"""
@generated by mypy-protobuf.  Do not edit manually!
isort:skip_file
"""

import abc
import collections.abc
import google.protobuf.empty_pb2
import grpc
import grpc.aio
import typing
import datasphere.yandex.cloud.priv.iam.v1.mfa.totp_profile_pb2
import datasphere.yandex.cloud.priv.iam.v1.mfa.totp_profile_service_pb2
import datasphere.yandex.cloud.priv.operation.operation_pb2

_T = typing.TypeVar("_T")

class _MaybeAsyncIterator(collections.abc.AsyncIterator[_T], collections.abc.Iterator[_T], metaclass=abc.ABCMeta): ...

class _ServicerContext(grpc.ServicerContext, grpc.aio.ServicerContext):  # type: ignore[misc, type-arg]
    ...

class TotpProfileServiceStub:
    """A set of methods for managing time-based one time passwords (TOTP).
    The user credentials should be passed in the authorization header.
    """

    def __init__(self, channel: typing.Union[grpc.Channel, grpc.aio.Channel]) -> None: ...
    Get: grpc.UnaryUnaryMultiCallable[
        google.protobuf.empty_pb2.Empty,
        yandex.cloud.priv.iam.v1.mfa.totp_profile_pb2.TotpProfile,
    ]
    """Returns the TOTP profile for the user."""

    Create: grpc.UnaryUnaryMultiCallable[
        yandex.cloud.priv.iam.v1.mfa.totp_profile_service_pb2.CreateTotpProfileRequest,
        yandex.cloud.priv.operation.operation_pb2.Operation,
    ]
    """Creates a new TOTP profile for the user. This method will fail, if the user
    already has an active MFA profile.
    """

    Delete: grpc.UnaryUnaryMultiCallable[
        yandex.cloud.priv.iam.v1.mfa.totp_profile_service_pb2.DeleteTotpProfileRequest,
        yandex.cloud.priv.operation.operation_pb2.Operation,
    ]
    """Deletes the TOTP profile for the user."""

    ListOperations: grpc.UnaryUnaryMultiCallable[
        yandex.cloud.priv.iam.v1.mfa.totp_profile_service_pb2.ListTotpProfileOperationsRequest,
        yandex.cloud.priv.iam.v1.mfa.totp_profile_service_pb2.ListTotpProfileOperationsResponse,
    ]
    """Retrieves the list of Operations for the specified TOTP profile."""

    Verify: grpc.UnaryUnaryMultiCallable[
        yandex.cloud.priv.iam.v1.mfa.totp_profile_service_pb2.VerifyTotpRequest,
        yandex.cloud.priv.iam.v1.mfa.totp_profile_service_pb2.VerifyTotpResponse,
    ]
    """Verifies user-supplied TOTP value. See https://tools.ietf.org/html/rfc6238#section-5.2 for the reference."""

    GetForSubject: grpc.UnaryUnaryMultiCallable[
        yandex.cloud.priv.iam.v1.mfa.totp_profile_service_pb2.GetTotpProfileForSubjectRequest,
        yandex.cloud.priv.iam.v1.mfa.totp_profile_pb2.TotpProfile,
    ]
    """Returns the TOTP profile for the specified user.
    This method requires `iam.totpProfiles.manage` permission.
    """

    DeleteForSubject: grpc.UnaryUnaryMultiCallable[
        yandex.cloud.priv.iam.v1.mfa.totp_profile_service_pb2.DeleteTotpProfileForSubjectRequest,
        yandex.cloud.priv.operation.operation_pb2.Operation,
    ]
    """Deletes the TOTP profile for the specified user.
    This method requires `iam.totpProfiles.manage` permission.
    """

class TotpProfileServiceAsyncStub:
    """A set of methods for managing time-based one time passwords (TOTP).
    The user credentials should be passed in the authorization header.
    """

    Get: grpc.aio.UnaryUnaryMultiCallable[
        google.protobuf.empty_pb2.Empty,
        yandex.cloud.priv.iam.v1.mfa.totp_profile_pb2.TotpProfile,
    ]
    """Returns the TOTP profile for the user."""

    Create: grpc.aio.UnaryUnaryMultiCallable[
        yandex.cloud.priv.iam.v1.mfa.totp_profile_service_pb2.CreateTotpProfileRequest,
        yandex.cloud.priv.operation.operation_pb2.Operation,
    ]
    """Creates a new TOTP profile for the user. This method will fail, if the user
    already has an active MFA profile.
    """

    Delete: grpc.aio.UnaryUnaryMultiCallable[
        yandex.cloud.priv.iam.v1.mfa.totp_profile_service_pb2.DeleteTotpProfileRequest,
        yandex.cloud.priv.operation.operation_pb2.Operation,
    ]
    """Deletes the TOTP profile for the user."""

    ListOperations: grpc.aio.UnaryUnaryMultiCallable[
        yandex.cloud.priv.iam.v1.mfa.totp_profile_service_pb2.ListTotpProfileOperationsRequest,
        yandex.cloud.priv.iam.v1.mfa.totp_profile_service_pb2.ListTotpProfileOperationsResponse,
    ]
    """Retrieves the list of Operations for the specified TOTP profile."""

    Verify: grpc.aio.UnaryUnaryMultiCallable[
        yandex.cloud.priv.iam.v1.mfa.totp_profile_service_pb2.VerifyTotpRequest,
        yandex.cloud.priv.iam.v1.mfa.totp_profile_service_pb2.VerifyTotpResponse,
    ]
    """Verifies user-supplied TOTP value. See https://tools.ietf.org/html/rfc6238#section-5.2 for the reference."""

    GetForSubject: grpc.aio.UnaryUnaryMultiCallable[
        yandex.cloud.priv.iam.v1.mfa.totp_profile_service_pb2.GetTotpProfileForSubjectRequest,
        yandex.cloud.priv.iam.v1.mfa.totp_profile_pb2.TotpProfile,
    ]
    """Returns the TOTP profile for the specified user.
    This method requires `iam.totpProfiles.manage` permission.
    """

    DeleteForSubject: grpc.aio.UnaryUnaryMultiCallable[
        yandex.cloud.priv.iam.v1.mfa.totp_profile_service_pb2.DeleteTotpProfileForSubjectRequest,
        yandex.cloud.priv.operation.operation_pb2.Operation,
    ]
    """Deletes the TOTP profile for the specified user.
    This method requires `iam.totpProfiles.manage` permission.
    """

class TotpProfileServiceServicer(metaclass=abc.ABCMeta):
    """A set of methods for managing time-based one time passwords (TOTP).
    The user credentials should be passed in the authorization header.
    """

    @abc.abstractmethod
    def Get(
        self,
        request: google.protobuf.empty_pb2.Empty,
        context: _ServicerContext,
    ) -> typing.Union[yandex.cloud.priv.iam.v1.mfa.totp_profile_pb2.TotpProfile, collections.abc.Awaitable[yandex.cloud.priv.iam.v1.mfa.totp_profile_pb2.TotpProfile]]:
        """Returns the TOTP profile for the user."""

    @abc.abstractmethod
    def Create(
        self,
        request: yandex.cloud.priv.iam.v1.mfa.totp_profile_service_pb2.CreateTotpProfileRequest,
        context: _ServicerContext,
    ) -> typing.Union[yandex.cloud.priv.operation.operation_pb2.Operation, collections.abc.Awaitable[yandex.cloud.priv.operation.operation_pb2.Operation]]:
        """Creates a new TOTP profile for the user. This method will fail, if the user
        already has an active MFA profile.
        """

    @abc.abstractmethod
    def Delete(
        self,
        request: yandex.cloud.priv.iam.v1.mfa.totp_profile_service_pb2.DeleteTotpProfileRequest,
        context: _ServicerContext,
    ) -> typing.Union[yandex.cloud.priv.operation.operation_pb2.Operation, collections.abc.Awaitable[yandex.cloud.priv.operation.operation_pb2.Operation]]:
        """Deletes the TOTP profile for the user."""

    @abc.abstractmethod
    def ListOperations(
        self,
        request: yandex.cloud.priv.iam.v1.mfa.totp_profile_service_pb2.ListTotpProfileOperationsRequest,
        context: _ServicerContext,
    ) -> typing.Union[yandex.cloud.priv.iam.v1.mfa.totp_profile_service_pb2.ListTotpProfileOperationsResponse, collections.abc.Awaitable[yandex.cloud.priv.iam.v1.mfa.totp_profile_service_pb2.ListTotpProfileOperationsResponse]]:
        """Retrieves the list of Operations for the specified TOTP profile."""

    @abc.abstractmethod
    def Verify(
        self,
        request: yandex.cloud.priv.iam.v1.mfa.totp_profile_service_pb2.VerifyTotpRequest,
        context: _ServicerContext,
    ) -> typing.Union[yandex.cloud.priv.iam.v1.mfa.totp_profile_service_pb2.VerifyTotpResponse, collections.abc.Awaitable[yandex.cloud.priv.iam.v1.mfa.totp_profile_service_pb2.VerifyTotpResponse]]:
        """Verifies user-supplied TOTP value. See https://tools.ietf.org/html/rfc6238#section-5.2 for the reference."""

    @abc.abstractmethod
    def GetForSubject(
        self,
        request: yandex.cloud.priv.iam.v1.mfa.totp_profile_service_pb2.GetTotpProfileForSubjectRequest,
        context: _ServicerContext,
    ) -> typing.Union[yandex.cloud.priv.iam.v1.mfa.totp_profile_pb2.TotpProfile, collections.abc.Awaitable[yandex.cloud.priv.iam.v1.mfa.totp_profile_pb2.TotpProfile]]:
        """Returns the TOTP profile for the specified user.
        This method requires `iam.totpProfiles.manage` permission.
        """

    @abc.abstractmethod
    def DeleteForSubject(
        self,
        request: yandex.cloud.priv.iam.v1.mfa.totp_profile_service_pb2.DeleteTotpProfileForSubjectRequest,
        context: _ServicerContext,
    ) -> typing.Union[yandex.cloud.priv.operation.operation_pb2.Operation, collections.abc.Awaitable[yandex.cloud.priv.operation.operation_pb2.Operation]]:
        """Deletes the TOTP profile for the specified user.
        This method requires `iam.totpProfiles.manage` permission.
        """

def add_TotpProfileServiceServicer_to_server(servicer: TotpProfileServiceServicer, server: typing.Union[grpc.Server, grpc.aio.Server]) -> None: ...
