"""
@generated by mypy-protobuf.  Do not edit manually!
isort:skip_file
"""

import builtins
import collections.abc
import google.protobuf.descriptor
import google.protobuf.duration_pb2
import google.protobuf.internal.containers
import google.protobuf.internal.enum_type_wrapper
import google.protobuf.message
import sys
import typing
import datasphere.yandex.cloud.priv.iam.v1.mfa.webauthn_profile_pb2
import datasphere.yandex.cloud.priv.operation.operation_pb2

if sys.version_info >= (3, 10):
    import typing as typing_extensions
else:
    import typing_extensions

DESCRIPTOR: google.protobuf.descriptor.FileDescriptor

class _UserVerificationRequirement:
    ValueType = typing.NewType("ValueType", builtins.int)
    V: typing_extensions.TypeAlias = ValueType

class _UserVerificationRequirementEnumTypeWrapper(google.protobuf.internal.enum_type_wrapper._EnumTypeWrapper[_UserVerificationRequirement.ValueType], builtins.type):
    DESCRIPTOR: google.protobuf.descriptor.EnumDescriptor
    USER_VERIFICATION_REQUIREMENT_UNSPECIFIED: _UserVerificationRequirement.ValueType  # 0
    USER_VERIFICATION_REQUIREMENT_DISCOURAGED: _UserVerificationRequirement.ValueType  # 1
    """The server does not want user verification employed during the operation."""
    USER_VERIFICATION_REQUIREMENT_PREFERRED: _UserVerificationRequirement.ValueType  # 2
    """It is preferred user verification for the operation if possible, but will not fail the operation if
    the response does not have the UV flag set.
    """
    USER_VERIFICATION_REQUIREMENT_REQUIRED: _UserVerificationRequirement.ValueType  # 3
    """It is required user verification for the operation and will fail the overall ceremony if the response
    does not have the UV flag set.
    """

class UserVerificationRequirement(_UserVerificationRequirement, metaclass=_UserVerificationRequirementEnumTypeWrapper):
    """User verification requirement enumeration. See https://www.w3.org/TR/webauthn-2/#enum-userVerificationRequirement."""

USER_VERIFICATION_REQUIREMENT_UNSPECIFIED: UserVerificationRequirement.ValueType  # 0
USER_VERIFICATION_REQUIREMENT_DISCOURAGED: UserVerificationRequirement.ValueType  # 1
"""The server does not want user verification employed during the operation."""
USER_VERIFICATION_REQUIREMENT_PREFERRED: UserVerificationRequirement.ValueType  # 2
"""It is preferred user verification for the operation if possible, but will not fail the operation if
the response does not have the UV flag set.
"""
USER_VERIFICATION_REQUIREMENT_REQUIRED: UserVerificationRequirement.ValueType  # 3
"""It is required user verification for the operation and will fail the overall ceremony if the response
does not have the UV flag set.
"""
global___UserVerificationRequirement = UserVerificationRequirement

class _PublicKeyCredentialType:
    ValueType = typing.NewType("ValueType", builtins.int)
    V: typing_extensions.TypeAlias = ValueType

class _PublicKeyCredentialTypeEnumTypeWrapper(google.protobuf.internal.enum_type_wrapper._EnumTypeWrapper[_PublicKeyCredentialType.ValueType], builtins.type):
    DESCRIPTOR: google.protobuf.descriptor.EnumDescriptor
    PUBLIC_KEY_CREDENTIAL_TYPE_UNSPECIFIED: _PublicKeyCredentialType.ValueType  # 0
    PUBLIC_KEY_CREDENTIAL_TYPE_PUBLIC_KEY: _PublicKeyCredentialType.ValueType  # 1

class PublicKeyCredentialType(_PublicKeyCredentialType, metaclass=_PublicKeyCredentialTypeEnumTypeWrapper):
    """Credential type enumeration. See https://www.w3.org/TR/webauthn-2/#enum-credentialType."""

PUBLIC_KEY_CREDENTIAL_TYPE_UNSPECIFIED: PublicKeyCredentialType.ValueType  # 0
PUBLIC_KEY_CREDENTIAL_TYPE_PUBLIC_KEY: PublicKeyCredentialType.ValueType  # 1
global___PublicKeyCredentialType = PublicKeyCredentialType

@typing.final
class GetWebAuthnProfileRequest(google.protobuf.message.Message):
    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    WEB_AUTHN_PROFILE_ID_FIELD_NUMBER: builtins.int
    web_authn_profile_id: builtins.str
    def __init__(
        self,
        *,
        web_authn_profile_id: builtins.str = ...,
    ) -> None: ...
    def ClearField(self, field_name: typing.Literal["web_authn_profile_id", b"web_authn_profile_id"]) -> None: ...

global___GetWebAuthnProfileRequest = GetWebAuthnProfileRequest

@typing.final
class ListWebAuthnProfilesRequest(google.protobuf.message.Message):
    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    PAGE_SIZE_FIELD_NUMBER: builtins.int
    PAGE_TOKEN_FIELD_NUMBER: builtins.int
    page_size: builtins.int
    page_token: builtins.str
    def __init__(
        self,
        *,
        page_size: builtins.int = ...,
        page_token: builtins.str = ...,
    ) -> None: ...
    def ClearField(self, field_name: typing.Literal["page_size", b"page_size", "page_token", b"page_token"]) -> None: ...

global___ListWebAuthnProfilesRequest = ListWebAuthnProfilesRequest

@typing.final
class ListWebAuthnProfilesResponse(google.protobuf.message.Message):
    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    PROFILES_FIELD_NUMBER: builtins.int
    NEXT_PAGE_TOKEN_FIELD_NUMBER: builtins.int
    next_page_token: builtins.str
    @property
    def profiles(self) -> google.protobuf.internal.containers.RepeatedCompositeFieldContainer[yandex.cloud.priv.iam.v1.mfa.webauthn_profile_pb2.WebAuthnProfile]: ...
    def __init__(
        self,
        *,
        profiles: collections.abc.Iterable[yandex.cloud.priv.iam.v1.mfa.webauthn_profile_pb2.WebAuthnProfile] | None = ...,
        next_page_token: builtins.str = ...,
    ) -> None: ...
    def ClearField(self, field_name: typing.Literal["next_page_token", b"next_page_token", "profiles", b"profiles"]) -> None: ...

global___ListWebAuthnProfilesResponse = ListWebAuthnProfilesResponse

@typing.final
class GetPublicKeyCredentialCreationOptionsResponse(google.protobuf.message.Message):
    """Representation of PublicKeyCredentialCreationOptions. See https://www.w3.org/TR/webauthn-2/#dictionary-makecredentialoptions.
    The value of the Rely party must be determined on the calling side and must be sent back in the CreateWebAuthnProfileRequest request.
    """

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    class _AuthenticatorAttachment:
        ValueType = typing.NewType("ValueType", builtins.int)
        V: typing_extensions.TypeAlias = ValueType

    class _AuthenticatorAttachmentEnumTypeWrapper(google.protobuf.internal.enum_type_wrapper._EnumTypeWrapper[GetPublicKeyCredentialCreationOptionsResponse._AuthenticatorAttachment.ValueType], builtins.type):
        DESCRIPTOR: google.protobuf.descriptor.EnumDescriptor
        AUTHENTICATOR_ATTACHMENT_UNSPECIFIED: GetPublicKeyCredentialCreationOptionsResponse._AuthenticatorAttachment.ValueType  # 0
        AUTHENTICATOR_ATTACHMENT_PLATFORM: GetPublicKeyCredentialCreationOptionsResponse._AuthenticatorAttachment.ValueType  # 1
        """Indicates platform attachment. See https://www.w3.org/TR/webauthn-2/#platform-attachment"""
        AUTHENTICATOR_ATTACHMENT_CROSS_PLATFORM: GetPublicKeyCredentialCreationOptionsResponse._AuthenticatorAttachment.ValueType  # 2
        """Indicates cross-platform attachment. See https://www.w3.org/TR/webauthn-2/#cross-platform-attachment"""

    class AuthenticatorAttachment(_AuthenticatorAttachment, metaclass=_AuthenticatorAttachmentEnumTypeWrapper):
        """Authenticator attachment enumeration. See https://www.w3.org/TR/webauthn-2/#enumdef-authenticatorattachment."""

    AUTHENTICATOR_ATTACHMENT_UNSPECIFIED: GetPublicKeyCredentialCreationOptionsResponse.AuthenticatorAttachment.ValueType  # 0
    AUTHENTICATOR_ATTACHMENT_PLATFORM: GetPublicKeyCredentialCreationOptionsResponse.AuthenticatorAttachment.ValueType  # 1
    """Indicates platform attachment. See https://www.w3.org/TR/webauthn-2/#platform-attachment"""
    AUTHENTICATOR_ATTACHMENT_CROSS_PLATFORM: GetPublicKeyCredentialCreationOptionsResponse.AuthenticatorAttachment.ValueType  # 2
    """Indicates cross-platform attachment. See https://www.w3.org/TR/webauthn-2/#cross-platform-attachment"""

    class _ResidentKeyRequirement:
        ValueType = typing.NewType("ValueType", builtins.int)
        V: typing_extensions.TypeAlias = ValueType

    class _ResidentKeyRequirementEnumTypeWrapper(google.protobuf.internal.enum_type_wrapper._EnumTypeWrapper[GetPublicKeyCredentialCreationOptionsResponse._ResidentKeyRequirement.ValueType], builtins.type):
        DESCRIPTOR: google.protobuf.descriptor.EnumDescriptor
        RESIDENT_KEY_REQUIREMENT_UNSPECIFIED: GetPublicKeyCredentialCreationOptionsResponse._ResidentKeyRequirement.ValueType  # 0
        RESIDENT_KEY_REQUIREMENT_DISCOURAGED: GetPublicKeyCredentialCreationOptionsResponse._ResidentKeyRequirement.ValueType  # 1
        """The server prefers creating a server-side credential, but will accept a client-side discoverable credential."""
        RESIDENT_KEY_REQUIREMENT_PREFERRED: GetPublicKeyCredentialCreationOptionsResponse._ResidentKeyRequirement.ValueType  # 2
        """The server strongly prefers creating a client-side discoverable credential, but will accept a server-side credential."""
        RESIDENT_KEY_REQUIREMENT_REQUIRED: GetPublicKeyCredentialCreationOptionsResponse._ResidentKeyRequirement.ValueType  # 3
        """The server requires a client-side discoverable credential."""

    class ResidentKeyRequirement(_ResidentKeyRequirement, metaclass=_ResidentKeyRequirementEnumTypeWrapper):
        """Resident key requirement enumeration. See https://www.w3.org/TR/webauthn-2/#enum-residentKeyRequirement."""

    RESIDENT_KEY_REQUIREMENT_UNSPECIFIED: GetPublicKeyCredentialCreationOptionsResponse.ResidentKeyRequirement.ValueType  # 0
    RESIDENT_KEY_REQUIREMENT_DISCOURAGED: GetPublicKeyCredentialCreationOptionsResponse.ResidentKeyRequirement.ValueType  # 1
    """The server prefers creating a server-side credential, but will accept a client-side discoverable credential."""
    RESIDENT_KEY_REQUIREMENT_PREFERRED: GetPublicKeyCredentialCreationOptionsResponse.ResidentKeyRequirement.ValueType  # 2
    """The server strongly prefers creating a client-side discoverable credential, but will accept a server-side credential."""
    RESIDENT_KEY_REQUIREMENT_REQUIRED: GetPublicKeyCredentialCreationOptionsResponse.ResidentKeyRequirement.ValueType  # 3
    """The server requires a client-side discoverable credential."""

    class _AttestationConveyancePreference:
        ValueType = typing.NewType("ValueType", builtins.int)
        V: typing_extensions.TypeAlias = ValueType

    class _AttestationConveyancePreferenceEnumTypeWrapper(google.protobuf.internal.enum_type_wrapper._EnumTypeWrapper[GetPublicKeyCredentialCreationOptionsResponse._AttestationConveyancePreference.ValueType], builtins.type):
        DESCRIPTOR: google.protobuf.descriptor.EnumDescriptor
        ATTESTATION_CONVEYANCE_PREFERENCE_UNSPECIFIED: GetPublicKeyCredentialCreationOptionsResponse._AttestationConveyancePreference.ValueType  # 0
        ATTESTATION_CONVEYANCE_PREFERENCE_INDIRECT: GetPublicKeyCredentialCreationOptionsResponse._AttestationConveyancePreference.ValueType  # 1
        """This value indicates that the server prefers an attestation conveyance yielding verifiable attestation statements, but allows the client to decide how to obtain such attestation statements"""
        ATTESTATION_CONVEYANCE_PREFERENCE_DIRECT: GetPublicKeyCredentialCreationOptionsResponse._AttestationConveyancePreference.ValueType  # 2
        """This value indicates that the server wants to receive the attestation statement as generated by the authenticator."""
        ATTESTATION_CONVEYANCE_PREFERENCE_ENTERPRISE: GetPublicKeyCredentialCreationOptionsResponse._AttestationConveyancePreference.ValueType  # 3
        """This value indicates that the server wants to receive an attestation statement that may include uniquely identifying information."""
        ATTESTATION_CONVEYANCE_PREFERENCE_NONE: GetPublicKeyCredentialCreationOptionsResponse._AttestationConveyancePreference.ValueType  # 4
        """This value indicates that the server is not interested in authenticator attestation."""

    class AttestationConveyancePreference(_AttestationConveyancePreference, metaclass=_AttestationConveyancePreferenceEnumTypeWrapper):
        """Attestation conveyance preference enumeration. See https://www.w3.org/TR/webauthn-2/#enum-attestation-convey."""

    ATTESTATION_CONVEYANCE_PREFERENCE_UNSPECIFIED: GetPublicKeyCredentialCreationOptionsResponse.AttestationConveyancePreference.ValueType  # 0
    ATTESTATION_CONVEYANCE_PREFERENCE_INDIRECT: GetPublicKeyCredentialCreationOptionsResponse.AttestationConveyancePreference.ValueType  # 1
    """This value indicates that the server prefers an attestation conveyance yielding verifiable attestation statements, but allows the client to decide how to obtain such attestation statements"""
    ATTESTATION_CONVEYANCE_PREFERENCE_DIRECT: GetPublicKeyCredentialCreationOptionsResponse.AttestationConveyancePreference.ValueType  # 2
    """This value indicates that the server wants to receive the attestation statement as generated by the authenticator."""
    ATTESTATION_CONVEYANCE_PREFERENCE_ENTERPRISE: GetPublicKeyCredentialCreationOptionsResponse.AttestationConveyancePreference.ValueType  # 3
    """This value indicates that the server wants to receive an attestation statement that may include uniquely identifying information."""
    ATTESTATION_CONVEYANCE_PREFERENCE_NONE: GetPublicKeyCredentialCreationOptionsResponse.AttestationConveyancePreference.ValueType  # 4
    """This value indicates that the server is not interested in authenticator attestation."""

    @typing.final
    class ExtensionsEntry(google.protobuf.message.Message):
        DESCRIPTOR: google.protobuf.descriptor.Descriptor

        KEY_FIELD_NUMBER: builtins.int
        VALUE_FIELD_NUMBER: builtins.int
        key: builtins.str
        value: builtins.str
        def __init__(
            self,
            *,
            key: builtins.str = ...,
            value: builtins.str = ...,
        ) -> None: ...
        def ClearField(self, field_name: typing.Literal["key", b"key", "value", b"value"]) -> None: ...

    @typing.final
    class PublicKeyCredentialUserEntity(google.protobuf.message.Message):
        """User account parameters. See https://www.w3.org/TR/webauthn-2/#dictdef-publickeycredentialuserentity."""

        DESCRIPTOR: google.protobuf.descriptor.Descriptor

        ID_FIELD_NUMBER: builtins.int
        NAME_FIELD_NUMBER: builtins.int
        DISPLAY_NAME_FIELD_NUMBER: builtins.int
        id: builtins.str
        """The user handle of the user account."""
        name: builtins.str
        """A human-palatable identifier for the user account."""
        display_name: builtins.str
        """A human-palatable name for the user account."""
        def __init__(
            self,
            *,
            id: builtins.str = ...,
            name: builtins.str = ...,
            display_name: builtins.str = ...,
        ) -> None: ...
        def ClearField(self, field_name: typing.Literal["display_name", b"display_name", "id", b"id", "name", b"name"]) -> None: ...

    @typing.final
    class PublicKeyCredentialParameters(google.protobuf.message.Message):
        """Parameters for credential generation. See https://www.w3.org/TR/webauthn-2/#dictdef-publickeycredentialparameters."""

        DESCRIPTOR: google.protobuf.descriptor.Descriptor

        TYPE_FIELD_NUMBER: builtins.int
        ALG_FIELD_NUMBER: builtins.int
        type: global___PublicKeyCredentialType.ValueType
        """Specifies the type of credential to be created."""
        alg: builtins.int
        """Specifies the cryptographic signature algorithm with which the newly generated credential will be used.
        The algorithm identifiers is values registered in the IANA COSE Algorithms registry.
        See https://www.iana.org/assignments/cose/cose.xhtml#algorithms
        """
        def __init__(
            self,
            *,
            type: global___PublicKeyCredentialType.ValueType = ...,
            alg: builtins.int = ...,
        ) -> None: ...
        def ClearField(self, field_name: typing.Literal["alg", b"alg", "type", b"type"]) -> None: ...

    @typing.final
    class AuthenticatorSelectionCriteria(google.protobuf.message.Message):
        """Authenticator selection criteria. See https://www.w3.org/TR/webauthn-2/#dictdef-authenticatorselectioncriteria."""

        DESCRIPTOR: google.protobuf.descriptor.Descriptor

        AUTHENTICATOR_ATTACHMENT_FIELD_NUMBER: builtins.int
        RESIDENT_KEY_FIELD_NUMBER: builtins.int
        REQUIRE_RESIDENT_KEY_FIELD_NUMBER: builtins.int
        USER_VERIFICATION_FIELD_NUMBER: builtins.int
        authenticator_attachment: global___GetPublicKeyCredentialCreationOptionsResponse.AuthenticatorAttachment.ValueType
        """If this member is present, eligible authenticators are filtered to be only those authenticators attached with the specified
        authenticator attachment modality.
        """
        resident_key: global___GetPublicKeyCredentialCreationOptionsResponse.ResidentKeyRequirement.ValueType
        """Specifies the extent to which the Relying Party desires to create a client-side discoverable credential."""
        require_resident_key: builtins.bool
        """This member is retained for backwards compatibility with WebAuthn Level 1."""
        user_verification: global___UserVerificationRequirement.ValueType
        """Specifies the Relying Party's requirements regarding user verification for the create() operation."""
        def __init__(
            self,
            *,
            authenticator_attachment: global___GetPublicKeyCredentialCreationOptionsResponse.AuthenticatorAttachment.ValueType = ...,
            resident_key: global___GetPublicKeyCredentialCreationOptionsResponse.ResidentKeyRequirement.ValueType = ...,
            require_resident_key: builtins.bool = ...,
            user_verification: global___UserVerificationRequirement.ValueType = ...,
        ) -> None: ...
        def ClearField(self, field_name: typing.Literal["authenticator_attachment", b"authenticator_attachment", "require_resident_key", b"require_resident_key", "resident_key", b"resident_key", "user_verification", b"user_verification"]) -> None: ...

    CHALLENGE_FIELD_NUMBER: builtins.int
    USER_FIELD_NUMBER: builtins.int
    PUB_KEY_CRED_PARAMS_FIELD_NUMBER: builtins.int
    TIMEOUT_FIELD_NUMBER: builtins.int
    EXCLUDE_CREDENTIALS_FIELD_NUMBER: builtins.int
    AUTHENTICATOR_SELECTION_FIELD_NUMBER: builtins.int
    ATTESTATION_FIELD_NUMBER: builtins.int
    EXTENSIONS_FIELD_NUMBER: builtins.int
    challenge: builtins.str
    """Contains a challenge intended to be used for generating the newly created credential's attestation object."""
    attestation: global___GetPublicKeyCredentialCreationOptionsResponse.AttestationConveyancePreference.ValueType
    """Specifies a preference regarding attestation conveyance."""
    @property
    def user(self) -> global___GetPublicKeyCredentialCreationOptionsResponse.PublicKeyCredentialUserEntity:
        """Contains names and an identifier for the user account performing the registration."""

    @property
    def pub_key_cred_params(self) -> google.protobuf.internal.containers.RepeatedCompositeFieldContainer[global___GetPublicKeyCredentialCreationOptionsResponse.PublicKeyCredentialParameters]:
        """Contains information about the desired properties of the credential to be created."""

    @property
    def timeout(self) -> google.protobuf.duration_pb2.Duration:
        """Specifies a time that the caller is willing to wait for the call to complete."""

    @property
    def exclude_credentials(self) -> google.protobuf.internal.containers.RepeatedCompositeFieldContainer[global___PublicKeyCredentialDescriptor]:
        """This member is intended to limit the creation of multiple credentials for the same account on a single authenticator."""

    @property
    def authenticator_selection(self) -> global___GetPublicKeyCredentialCreationOptionsResponse.AuthenticatorSelectionCriteria:
        """This member is intended to select the appropriate authenticators to participate in the create() operation."""

    @property
    def extensions(self) -> google.protobuf.internal.containers.ScalarMap[builtins.str, builtins.str]:
        """Contains additional parameters requesting additional processing by the client and authenticator."""

    def __init__(
        self,
        *,
        challenge: builtins.str = ...,
        user: global___GetPublicKeyCredentialCreationOptionsResponse.PublicKeyCredentialUserEntity | None = ...,
        pub_key_cred_params: collections.abc.Iterable[global___GetPublicKeyCredentialCreationOptionsResponse.PublicKeyCredentialParameters] | None = ...,
        timeout: google.protobuf.duration_pb2.Duration | None = ...,
        exclude_credentials: collections.abc.Iterable[global___PublicKeyCredentialDescriptor] | None = ...,
        authenticator_selection: global___GetPublicKeyCredentialCreationOptionsResponse.AuthenticatorSelectionCriteria | None = ...,
        attestation: global___GetPublicKeyCredentialCreationOptionsResponse.AttestationConveyancePreference.ValueType = ...,
        extensions: collections.abc.Mapping[builtins.str, builtins.str] | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing.Literal["authenticator_selection", b"authenticator_selection", "timeout", b"timeout", "user", b"user"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing.Literal["attestation", b"attestation", "authenticator_selection", b"authenticator_selection", "challenge", b"challenge", "exclude_credentials", b"exclude_credentials", "extensions", b"extensions", "pub_key_cred_params", b"pub_key_cred_params", "timeout", b"timeout", "user", b"user"]) -> None: ...

global___GetPublicKeyCredentialCreationOptionsResponse = GetPublicKeyCredentialCreationOptionsResponse

@typing.final
class PublicKeyCredentialDescriptor(google.protobuf.message.Message):
    """Credential descriptor. See https://www.w3.org/TR/webauthn-2/#dictdef-publickeycredentialdescriptor."""

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    TYPE_FIELD_NUMBER: builtins.int
    ID_FIELD_NUMBER: builtins.int
    TRANSPORTS_FIELD_NUMBER: builtins.int
    type: global___PublicKeyCredentialType.ValueType
    """Contains the type of the public key credential the caller is referring to"""
    id: builtins.str
    """Credential ID of the public key credential the caller is referring to"""
    @property
    def transports(self) -> google.protobuf.internal.containers.RepeatedScalarFieldContainer[builtins.str]:
        """Contains hints as to how the client might communicate with the managing authenticator of the public
        key credential the caller is referring to.
        """

    def __init__(
        self,
        *,
        type: global___PublicKeyCredentialType.ValueType = ...,
        id: builtins.str = ...,
        transports: collections.abc.Iterable[builtins.str] | None = ...,
    ) -> None: ...
    def ClearField(self, field_name: typing.Literal["id", b"id", "transports", b"transports", "type", b"type"]) -> None: ...

global___PublicKeyCredentialDescriptor = PublicKeyCredentialDescriptor

@typing.final
class CreateWebAuthnProfileRequest(google.protobuf.message.Message):
    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    ORIGIN_FIELD_NUMBER: builtins.int
    RP_ID_FIELD_NUMBER: builtins.int
    CLIENT_DATA_JSON_FIELD_NUMBER: builtins.int
    ATTESTATION_OBJECT_FIELD_NUMBER: builtins.int
    origin: builtins.str
    """The fully qualified origin of the requester passed to the authenticator by the client in order to generate this credential"""
    rp_id: builtins.str
    """A unique identifier for the Relying Party entity passed to the authenticator by the client in order to generate this credential"""
    client_data_json: builtins.str
    """Contains the JSON-compatible serialization of client data passed to the authenticator by the client in order to generate this credential.
    Must be base64_url encoded.
    """
    attestation_object: builtins.str
    """Attestation object, which is opaque to, and cryptographically protected against tampering by, the client.
    Must be base64_url encoded.
    """
    def __init__(
        self,
        *,
        origin: builtins.str = ...,
        rp_id: builtins.str = ...,
        client_data_json: builtins.str = ...,
        attestation_object: builtins.str = ...,
    ) -> None: ...
    def ClearField(self, field_name: typing.Literal["attestation_object", b"attestation_object", "client_data_json", b"client_data_json", "origin", b"origin", "rp_id", b"rp_id"]) -> None: ...

global___CreateWebAuthnProfileRequest = CreateWebAuthnProfileRequest

@typing.final
class CreateWebAuthnProfileMetadata(google.protobuf.message.Message):
    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    WEB_AUTHN_PROFILE_ID_FIELD_NUMBER: builtins.int
    web_authn_profile_id: builtins.str
    def __init__(
        self,
        *,
        web_authn_profile_id: builtins.str = ...,
    ) -> None: ...
    def ClearField(self, field_name: typing.Literal["web_authn_profile_id", b"web_authn_profile_id"]) -> None: ...

global___CreateWebAuthnProfileMetadata = CreateWebAuthnProfileMetadata

@typing.final
class CreateWebAuthnProfileResponse(google.protobuf.message.Message):
    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    WEB_AUTHN_PROFILE_FIELD_NUMBER: builtins.int
    SET_COOKIE_HEADER_FIELD_NUMBER: builtins.int
    @property
    def web_authn_profile(self) -> yandex.cloud.priv.iam.v1.mfa.webauthn_profile_pb2.WebAuthnProfile:
        """Newly created WebAuthn profile."""

    @property
    def set_cookie_header(self) -> google.protobuf.internal.containers.RepeatedScalarFieldContainer[builtins.str]:
        """HTTP-header Set-Cookie for End-User with required per-service cookies, e.g. yc_session.
        See also yandex/cloud/priv/oauth/v1/session_service.proto specification.
        """

    def __init__(
        self,
        *,
        web_authn_profile: yandex.cloud.priv.iam.v1.mfa.webauthn_profile_pb2.WebAuthnProfile | None = ...,
        set_cookie_header: collections.abc.Iterable[builtins.str] | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing.Literal["web_authn_profile", b"web_authn_profile"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing.Literal["set_cookie_header", b"set_cookie_header", "web_authn_profile", b"web_authn_profile"]) -> None: ...

global___CreateWebAuthnProfileResponse = CreateWebAuthnProfileResponse

@typing.final
class GetPublicKeyCredentialRequestOptionsResponse(google.protobuf.message.Message):
    """Representation of PublicKeyCredentialRequestOptions. See https://www.w3.org/TR/webauthn-2/#dictionary-assertion-options.
    The value of the Rely party must be determined on the calling side and must be sent back in the
    VerifyWebAuthnProfileRequest or DeleteWebAuthnProfileRequest request.
    """

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    @typing.final
    class ExtensionsEntry(google.protobuf.message.Message):
        DESCRIPTOR: google.protobuf.descriptor.Descriptor

        KEY_FIELD_NUMBER: builtins.int
        VALUE_FIELD_NUMBER: builtins.int
        key: builtins.str
        value: builtins.str
        def __init__(
            self,
            *,
            key: builtins.str = ...,
            value: builtins.str = ...,
        ) -> None: ...
        def ClearField(self, field_name: typing.Literal["key", b"key", "value", b"value"]) -> None: ...

    CHALLENGE_FIELD_NUMBER: builtins.int
    TIMEOUT_FIELD_NUMBER: builtins.int
    ALLOW_CREDENTIALS_FIELD_NUMBER: builtins.int
    USER_VERIFICATION_FIELD_NUMBER: builtins.int
    EXTENSIONS_FIELD_NUMBER: builtins.int
    challenge: builtins.str
    """Represents a challenge that the selected authenticator signs, along with other data, when producing an authentication assertion."""
    user_verification: global___UserVerificationRequirement.ValueType
    """Specifies requirements regarding user verification for the get() operation."""
    @property
    def timeout(self) -> google.protobuf.duration_pb2.Duration:
        """Specifies a time that the caller is willing to wait for the call to complete."""

    @property
    def allow_credentials(self) -> google.protobuf.internal.containers.RepeatedCompositeFieldContainer[global___PublicKeyCredentialDescriptor]:
        """Contains a list of acceptable public key credentials, in descending order of the caller's preference"""

    @property
    def extensions(self) -> google.protobuf.internal.containers.ScalarMap[builtins.str, builtins.str]:
        """Contains additional parameters requesting additional processing by the client and authenticator."""

    def __init__(
        self,
        *,
        challenge: builtins.str = ...,
        timeout: google.protobuf.duration_pb2.Duration | None = ...,
        allow_credentials: collections.abc.Iterable[global___PublicKeyCredentialDescriptor] | None = ...,
        user_verification: global___UserVerificationRequirement.ValueType = ...,
        extensions: collections.abc.Mapping[builtins.str, builtins.str] | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing.Literal["timeout", b"timeout"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing.Literal["allow_credentials", b"allow_credentials", "challenge", b"challenge", "extensions", b"extensions", "timeout", b"timeout", "user_verification", b"user_verification"]) -> None: ...

global___GetPublicKeyCredentialRequestOptionsResponse = GetPublicKeyCredentialRequestOptionsResponse

@typing.final
class DeleteWebAuthnProfileRequest(google.protobuf.message.Message):
    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    ORIGIN_FIELD_NUMBER: builtins.int
    RP_ID_FIELD_NUMBER: builtins.int
    ASSERTION_RESULT_FIELD_NUMBER: builtins.int
    WEB_AUTHN_PROFILE_ID_FIELD_NUMBER: builtins.int
    origin: builtins.str
    """The fully qualified origin of the requester passed to the authenticator by the client in order to generate this credential."""
    rp_id: builtins.str
    """A unique identifier for the Relying Party entity passed to the authenticator by the client in order to generate this credential."""
    web_authn_profile_id: builtins.str
    """ID of the profile to be deleted"""
    @property
    def assertion_result(self) -> global___AssertionResult:
        """Result of calling get-assertion authenticator method"""

    def __init__(
        self,
        *,
        origin: builtins.str = ...,
        rp_id: builtins.str = ...,
        assertion_result: global___AssertionResult | None = ...,
        web_authn_profile_id: builtins.str = ...,
    ) -> None: ...
    def HasField(self, field_name: typing.Literal["assertion_result", b"assertion_result"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing.Literal["assertion_result", b"assertion_result", "origin", b"origin", "rp_id", b"rp_id", "web_authn_profile_id", b"web_authn_profile_id"]) -> None: ...

global___DeleteWebAuthnProfileRequest = DeleteWebAuthnProfileRequest

@typing.final
class DeleteWebAuthnProfileMetadata(google.protobuf.message.Message):
    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    WEB_AUTHN_PROFILE_ID_FIELD_NUMBER: builtins.int
    web_authn_profile_id: builtins.str
    def __init__(
        self,
        *,
        web_authn_profile_id: builtins.str = ...,
    ) -> None: ...
    def ClearField(self, field_name: typing.Literal["web_authn_profile_id", b"web_authn_profile_id"]) -> None: ...

global___DeleteWebAuthnProfileMetadata = DeleteWebAuthnProfileMetadata

@typing.final
class VerifyWebAuthnProfileRequest(google.protobuf.message.Message):
    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    ORIGIN_FIELD_NUMBER: builtins.int
    RP_ID_FIELD_NUMBER: builtins.int
    ASSERTION_RESULT_FIELD_NUMBER: builtins.int
    origin: builtins.str
    """The fully qualified origin of the requester passed to the authenticator by the client in order to generate this credential."""
    rp_id: builtins.str
    """A unique identifier for the Relying Party entity passed to the authenticator by the client in order to generate this credential."""
    @property
    def assertion_result(self) -> global___AssertionResult:
        """Result of calling get-assertion authenticator method"""

    def __init__(
        self,
        *,
        origin: builtins.str = ...,
        rp_id: builtins.str = ...,
        assertion_result: global___AssertionResult | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing.Literal["assertion_result", b"assertion_result"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing.Literal["assertion_result", b"assertion_result", "origin", b"origin", "rp_id", b"rp_id"]) -> None: ...

global___VerifyWebAuthnProfileRequest = VerifyWebAuthnProfileRequest

@typing.final
class AssertionResult(google.protobuf.message.Message):
    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    CREDENTIAL_ID_FIELD_NUMBER: builtins.int
    CLIENT_DATA_JSON_FIELD_NUMBER: builtins.int
    AUTHENTICATOR_DATA_FIELD_NUMBER: builtins.int
    SIGNATURE_FIELD_NUMBER: builtins.int
    USER_HANDLE_FIELD_NUMBER: builtins.int
    credential_id: builtins.str
    """The identifier of credential used for getting assertion."""
    client_data_json: builtins.str
    """This attribute, inherited from AuthenticatorResponse, contains the JSON-compatible serialization of client data.
    Must be base64_url encoded.
    """
    authenticator_data: builtins.str
    """The authenticator data returned by the authenticator.
    Must be base64_url encoded.
    """
    signature: builtins.str
    """Contains the raw signature returned from the authenticator.
    Must be base64_url encoded.
    """
    user_handle: builtins.str
    """Contains the user handle returned from the authenticator.
    Must be base64_url encoded.
    """
    def __init__(
        self,
        *,
        credential_id: builtins.str = ...,
        client_data_json: builtins.str = ...,
        authenticator_data: builtins.str = ...,
        signature: builtins.str = ...,
        user_handle: builtins.str = ...,
    ) -> None: ...
    def ClearField(self, field_name: typing.Literal["authenticator_data", b"authenticator_data", "client_data_json", b"client_data_json", "credential_id", b"credential_id", "signature", b"signature", "user_handle", b"user_handle"]) -> None: ...

global___AssertionResult = AssertionResult

@typing.final
class VerifyWebAuthnResponse(google.protobuf.message.Message):
    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    RESULT_FIELD_NUMBER: builtins.int
    SET_COOKIE_HEADER_FIELD_NUMBER: builtins.int
    result: yandex.cloud.priv.iam.v1.mfa.webauthn_profile_pb2.WebAuthnVerificationResult.ValueType
    @property
    def set_cookie_header(self) -> google.protobuf.internal.containers.RepeatedScalarFieldContainer[builtins.str]:
        """HTTP-header Set-Cookie for End-User with required per-service cookies, e.g. yc_session.
        See also yandex/cloud/priv/oauth/v1/session_service.proto specification.
        """

    def __init__(
        self,
        *,
        result: yandex.cloud.priv.iam.v1.mfa.webauthn_profile_pb2.WebAuthnVerificationResult.ValueType = ...,
        set_cookie_header: collections.abc.Iterable[builtins.str] | None = ...,
    ) -> None: ...
    def ClearField(self, field_name: typing.Literal["result", b"result", "set_cookie_header", b"set_cookie_header"]) -> None: ...

global___VerifyWebAuthnResponse = VerifyWebAuthnResponse

@typing.final
class ListWebAuthnProfilesForSubjectRequest(google.protobuf.message.Message):
    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    SUBJECT_ID_FIELD_NUMBER: builtins.int
    PAGE_SIZE_FIELD_NUMBER: builtins.int
    PAGE_TOKEN_FIELD_NUMBER: builtins.int
    subject_id: builtins.str
    page_size: builtins.int
    page_token: builtins.str
    def __init__(
        self,
        *,
        subject_id: builtins.str = ...,
        page_size: builtins.int = ...,
        page_token: builtins.str = ...,
    ) -> None: ...
    def ClearField(self, field_name: typing.Literal["page_size", b"page_size", "page_token", b"page_token", "subject_id", b"subject_id"]) -> None: ...

global___ListWebAuthnProfilesForSubjectRequest = ListWebAuthnProfilesForSubjectRequest

@typing.final
class DeleteWebAuthnProfileForSubjectRequest(google.protobuf.message.Message):
    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    WEB_AUTHN_PROFILE_ID_FIELD_NUMBER: builtins.int
    web_authn_profile_id: builtins.str
    def __init__(
        self,
        *,
        web_authn_profile_id: builtins.str = ...,
    ) -> None: ...
    def ClearField(self, field_name: typing.Literal["web_authn_profile_id", b"web_authn_profile_id"]) -> None: ...

global___DeleteWebAuthnProfileForSubjectRequest = DeleteWebAuthnProfileForSubjectRequest

@typing.final
class DeleteWebAuthnProfilesProfileForSubjectMetadata(google.protobuf.message.Message):
    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    WEB_AUTHN_PROFILE_ID_FIELD_NUMBER: builtins.int
    web_authn_profile_id: builtins.str
    def __init__(
        self,
        *,
        web_authn_profile_id: builtins.str = ...,
    ) -> None: ...
    def ClearField(self, field_name: typing.Literal["web_authn_profile_id", b"web_authn_profile_id"]) -> None: ...

global___DeleteWebAuthnProfilesProfileForSubjectMetadata = DeleteWebAuthnProfilesProfileForSubjectMetadata

@typing.final
class ListWebAuthnProfileOperationsRequest(google.protobuf.message.Message):
    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    PAGE_SIZE_FIELD_NUMBER: builtins.int
    PAGE_TOKEN_FIELD_NUMBER: builtins.int
    ON_BEHALF_OF_SUBJECT_ID_FIELD_NUMBER: builtins.int
    page_size: builtins.int
    page_token: builtins.str
    on_behalf_of_subject_id: builtins.str
    def __init__(
        self,
        *,
        page_size: builtins.int = ...,
        page_token: builtins.str = ...,
        on_behalf_of_subject_id: builtins.str = ...,
    ) -> None: ...
    def ClearField(self, field_name: typing.Literal["on_behalf_of_subject_id", b"on_behalf_of_subject_id", "page_size", b"page_size", "page_token", b"page_token"]) -> None: ...

global___ListWebAuthnProfileOperationsRequest = ListWebAuthnProfileOperationsRequest

@typing.final
class ListWebAuthnProfileOperationsResponse(google.protobuf.message.Message):
    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    OPERATIONS_FIELD_NUMBER: builtins.int
    NEXT_PAGE_TOKEN_FIELD_NUMBER: builtins.int
    next_page_token: builtins.str
    @property
    def operations(self) -> google.protobuf.internal.containers.RepeatedCompositeFieldContainer[yandex.cloud.priv.operation.operation_pb2.Operation]: ...
    def __init__(
        self,
        *,
        operations: collections.abc.Iterable[yandex.cloud.priv.operation.operation_pb2.Operation] | None = ...,
        next_page_token: builtins.str = ...,
    ) -> None: ...
    def ClearField(self, field_name: typing.Literal["next_page_token", b"next_page_token", "operations", b"operations"]) -> None: ...

global___ListWebAuthnProfileOperationsResponse = ListWebAuthnProfileOperationsResponse
