"""
@generated by mypy-protobuf.  Do not edit manually!
isort:skip_file
"""

import abc
import collections.abc
import google.protobuf.empty_pb2
import grpc
import grpc.aio
import typing
import datasphere.yandex.cloud.priv.iam.v1.mfa.webauthn_profile_pb2
import datasphere.yandex.cloud.priv.iam.v1.mfa.webauthn_profile_service_pb2
import datasphere.yandex.cloud.priv.operation.operation_pb2

_T = typing.TypeVar("_T")

class _MaybeAsyncIterator(collections.abc.AsyncIterator[_T], collections.abc.Iterator[_T], metaclass=abc.ABCMeta): ...

class _ServicerContext(grpc.ServicerContext, grpc.aio.ServicerContext):  # type: ignore[misc, type-arg]
    ...

class WebAuthnProfileServiceStub:
    """A set of methods for managing web-authn profiles.
    The user credentials should be passed in the authorization header.
    """

    def __init__(self, channel: typing.Union[grpc.Channel, grpc.aio.Channel]) -> None: ...
    Get: grpc.UnaryUnaryMultiCallable[
        yandex.cloud.priv.iam.v1.mfa.webauthn_profile_service_pb2.GetWebAuthnProfileRequest,
        yandex.cloud.priv.iam.v1.mfa.webauthn_profile_pb2.WebAuthnProfile,
    ]
    """Returns the WebAuthn profile for the user and the specified credential."""

    List: grpc.UnaryUnaryMultiCallable[
        yandex.cloud.priv.iam.v1.mfa.webauthn_profile_service_pb2.ListWebAuthnProfilesRequest,
        yandex.cloud.priv.iam.v1.mfa.webauthn_profile_service_pb2.ListWebAuthnProfilesResponse,
    ]
    """Returns all WebAuthn profiles for the user."""

    GetPublicKeyCredentialCreationOptions: grpc.UnaryUnaryMultiCallable[
        google.protobuf.empty_pb2.Empty,
        yandex.cloud.priv.iam.v1.mfa.webauthn_profile_service_pb2.GetPublicKeyCredentialCreationOptionsResponse,
    ]
    """Returns options for creating credential in authenticator with make_credential method.
    The method is used as a part of Registration ceremony for creating WebAuthn profile
    """

    Create: grpc.UnaryUnaryMultiCallable[
        yandex.cloud.priv.iam.v1.mfa.webauthn_profile_service_pb2.CreateWebAuthnProfileRequest,
        yandex.cloud.priv.operation.operation_pb2.Operation,
    ]
    """Creates a new WebAuthn profile for the user. This method will fail, if the user
    already has an active MFA profile.
    """

    GetPublicKeyCredentialRequestOptions: grpc.UnaryUnaryMultiCallable[
        google.protobuf.empty_pb2.Empty,
        yandex.cloud.priv.iam.v1.mfa.webauthn_profile_service_pb2.GetPublicKeyCredentialRequestOptionsResponse,
    ]
    """Returns options for requesting credential in authenticator with get_assertion method
    The method is used as a part of Authentication ceremony for deleting or verifying WebAuthn profile
    """

    Delete: grpc.UnaryUnaryMultiCallable[
        yandex.cloud.priv.iam.v1.mfa.webauthn_profile_service_pb2.DeleteWebAuthnProfileRequest,
        yandex.cloud.priv.operation.operation_pb2.Operation,
    ]
    """Deletes the WebAuthn profile for the user."""

    Verify: grpc.UnaryUnaryMultiCallable[
        yandex.cloud.priv.iam.v1.mfa.webauthn_profile_service_pb2.VerifyWebAuthnProfileRequest,
        yandex.cloud.priv.iam.v1.mfa.webauthn_profile_service_pb2.VerifyWebAuthnResponse,
    ]
    """Verifies WebAuthn profile."""

    ListForSubject: grpc.UnaryUnaryMultiCallable[
        yandex.cloud.priv.iam.v1.mfa.webauthn_profile_service_pb2.ListWebAuthnProfilesForSubjectRequest,
        yandex.cloud.priv.iam.v1.mfa.webauthn_profile_service_pb2.ListWebAuthnProfilesResponse,
    ]
    """Returns the WebAuthn profile for the specified user.
    This method requires `iam.webAuthnProfiles.manage` permission.
    """

    DeleteForSubject: grpc.UnaryUnaryMultiCallable[
        yandex.cloud.priv.iam.v1.mfa.webauthn_profile_service_pb2.DeleteWebAuthnProfileForSubjectRequest,
        yandex.cloud.priv.operation.operation_pb2.Operation,
    ]
    """Deletes the webAuthnProfiles profile for the specified user.
    This method requires `iam.webAuthnProfiles.manage` permission.
    """

    ListOperations: grpc.UnaryUnaryMultiCallable[
        yandex.cloud.priv.iam.v1.mfa.webauthn_profile_service_pb2.ListWebAuthnProfileOperationsRequest,
        yandex.cloud.priv.iam.v1.mfa.webauthn_profile_service_pb2.ListWebAuthnProfileOperationsResponse,
    ]
    """Retrieves the list of subject's operations."""

class WebAuthnProfileServiceAsyncStub:
    """A set of methods for managing web-authn profiles.
    The user credentials should be passed in the authorization header.
    """

    Get: grpc.aio.UnaryUnaryMultiCallable[
        yandex.cloud.priv.iam.v1.mfa.webauthn_profile_service_pb2.GetWebAuthnProfileRequest,
        yandex.cloud.priv.iam.v1.mfa.webauthn_profile_pb2.WebAuthnProfile,
    ]
    """Returns the WebAuthn profile for the user and the specified credential."""

    List: grpc.aio.UnaryUnaryMultiCallable[
        yandex.cloud.priv.iam.v1.mfa.webauthn_profile_service_pb2.ListWebAuthnProfilesRequest,
        yandex.cloud.priv.iam.v1.mfa.webauthn_profile_service_pb2.ListWebAuthnProfilesResponse,
    ]
    """Returns all WebAuthn profiles for the user."""

    GetPublicKeyCredentialCreationOptions: grpc.aio.UnaryUnaryMultiCallable[
        google.protobuf.empty_pb2.Empty,
        yandex.cloud.priv.iam.v1.mfa.webauthn_profile_service_pb2.GetPublicKeyCredentialCreationOptionsResponse,
    ]
    """Returns options for creating credential in authenticator with make_credential method.
    The method is used as a part of Registration ceremony for creating WebAuthn profile
    """

    Create: grpc.aio.UnaryUnaryMultiCallable[
        yandex.cloud.priv.iam.v1.mfa.webauthn_profile_service_pb2.CreateWebAuthnProfileRequest,
        yandex.cloud.priv.operation.operation_pb2.Operation,
    ]
    """Creates a new WebAuthn profile for the user. This method will fail, if the user
    already has an active MFA profile.
    """

    GetPublicKeyCredentialRequestOptions: grpc.aio.UnaryUnaryMultiCallable[
        google.protobuf.empty_pb2.Empty,
        yandex.cloud.priv.iam.v1.mfa.webauthn_profile_service_pb2.GetPublicKeyCredentialRequestOptionsResponse,
    ]
    """Returns options for requesting credential in authenticator with get_assertion method
    The method is used as a part of Authentication ceremony for deleting or verifying WebAuthn profile
    """

    Delete: grpc.aio.UnaryUnaryMultiCallable[
        yandex.cloud.priv.iam.v1.mfa.webauthn_profile_service_pb2.DeleteWebAuthnProfileRequest,
        yandex.cloud.priv.operation.operation_pb2.Operation,
    ]
    """Deletes the WebAuthn profile for the user."""

    Verify: grpc.aio.UnaryUnaryMultiCallable[
        yandex.cloud.priv.iam.v1.mfa.webauthn_profile_service_pb2.VerifyWebAuthnProfileRequest,
        yandex.cloud.priv.iam.v1.mfa.webauthn_profile_service_pb2.VerifyWebAuthnResponse,
    ]
    """Verifies WebAuthn profile."""

    ListForSubject: grpc.aio.UnaryUnaryMultiCallable[
        yandex.cloud.priv.iam.v1.mfa.webauthn_profile_service_pb2.ListWebAuthnProfilesForSubjectRequest,
        yandex.cloud.priv.iam.v1.mfa.webauthn_profile_service_pb2.ListWebAuthnProfilesResponse,
    ]
    """Returns the WebAuthn profile for the specified user.
    This method requires `iam.webAuthnProfiles.manage` permission.
    """

    DeleteForSubject: grpc.aio.UnaryUnaryMultiCallable[
        yandex.cloud.priv.iam.v1.mfa.webauthn_profile_service_pb2.DeleteWebAuthnProfileForSubjectRequest,
        yandex.cloud.priv.operation.operation_pb2.Operation,
    ]
    """Deletes the webAuthnProfiles profile for the specified user.
    This method requires `iam.webAuthnProfiles.manage` permission.
    """

    ListOperations: grpc.aio.UnaryUnaryMultiCallable[
        yandex.cloud.priv.iam.v1.mfa.webauthn_profile_service_pb2.ListWebAuthnProfileOperationsRequest,
        yandex.cloud.priv.iam.v1.mfa.webauthn_profile_service_pb2.ListWebAuthnProfileOperationsResponse,
    ]
    """Retrieves the list of subject's operations."""

class WebAuthnProfileServiceServicer(metaclass=abc.ABCMeta):
    """A set of methods for managing web-authn profiles.
    The user credentials should be passed in the authorization header.
    """

    @abc.abstractmethod
    def Get(
        self,
        request: yandex.cloud.priv.iam.v1.mfa.webauthn_profile_service_pb2.GetWebAuthnProfileRequest,
        context: _ServicerContext,
    ) -> typing.Union[yandex.cloud.priv.iam.v1.mfa.webauthn_profile_pb2.WebAuthnProfile, collections.abc.Awaitable[yandex.cloud.priv.iam.v1.mfa.webauthn_profile_pb2.WebAuthnProfile]]:
        """Returns the WebAuthn profile for the user and the specified credential."""

    @abc.abstractmethod
    def List(
        self,
        request: yandex.cloud.priv.iam.v1.mfa.webauthn_profile_service_pb2.ListWebAuthnProfilesRequest,
        context: _ServicerContext,
    ) -> typing.Union[yandex.cloud.priv.iam.v1.mfa.webauthn_profile_service_pb2.ListWebAuthnProfilesResponse, collections.abc.Awaitable[yandex.cloud.priv.iam.v1.mfa.webauthn_profile_service_pb2.ListWebAuthnProfilesResponse]]:
        """Returns all WebAuthn profiles for the user."""

    @abc.abstractmethod
    def GetPublicKeyCredentialCreationOptions(
        self,
        request: google.protobuf.empty_pb2.Empty,
        context: _ServicerContext,
    ) -> typing.Union[yandex.cloud.priv.iam.v1.mfa.webauthn_profile_service_pb2.GetPublicKeyCredentialCreationOptionsResponse, collections.abc.Awaitable[yandex.cloud.priv.iam.v1.mfa.webauthn_profile_service_pb2.GetPublicKeyCredentialCreationOptionsResponse]]:
        """Returns options for creating credential in authenticator with make_credential method.
        The method is used as a part of Registration ceremony for creating WebAuthn profile
        """

    @abc.abstractmethod
    def Create(
        self,
        request: yandex.cloud.priv.iam.v1.mfa.webauthn_profile_service_pb2.CreateWebAuthnProfileRequest,
        context: _ServicerContext,
    ) -> typing.Union[yandex.cloud.priv.operation.operation_pb2.Operation, collections.abc.Awaitable[yandex.cloud.priv.operation.operation_pb2.Operation]]:
        """Creates a new WebAuthn profile for the user. This method will fail, if the user
        already has an active MFA profile.
        """

    @abc.abstractmethod
    def GetPublicKeyCredentialRequestOptions(
        self,
        request: google.protobuf.empty_pb2.Empty,
        context: _ServicerContext,
    ) -> typing.Union[yandex.cloud.priv.iam.v1.mfa.webauthn_profile_service_pb2.GetPublicKeyCredentialRequestOptionsResponse, collections.abc.Awaitable[yandex.cloud.priv.iam.v1.mfa.webauthn_profile_service_pb2.GetPublicKeyCredentialRequestOptionsResponse]]:
        """Returns options for requesting credential in authenticator with get_assertion method
        The method is used as a part of Authentication ceremony for deleting or verifying WebAuthn profile
        """

    @abc.abstractmethod
    def Delete(
        self,
        request: yandex.cloud.priv.iam.v1.mfa.webauthn_profile_service_pb2.DeleteWebAuthnProfileRequest,
        context: _ServicerContext,
    ) -> typing.Union[yandex.cloud.priv.operation.operation_pb2.Operation, collections.abc.Awaitable[yandex.cloud.priv.operation.operation_pb2.Operation]]:
        """Deletes the WebAuthn profile for the user."""

    @abc.abstractmethod
    def Verify(
        self,
        request: yandex.cloud.priv.iam.v1.mfa.webauthn_profile_service_pb2.VerifyWebAuthnProfileRequest,
        context: _ServicerContext,
    ) -> typing.Union[yandex.cloud.priv.iam.v1.mfa.webauthn_profile_service_pb2.VerifyWebAuthnResponse, collections.abc.Awaitable[yandex.cloud.priv.iam.v1.mfa.webauthn_profile_service_pb2.VerifyWebAuthnResponse]]:
        """Verifies WebAuthn profile."""

    @abc.abstractmethod
    def ListForSubject(
        self,
        request: yandex.cloud.priv.iam.v1.mfa.webauthn_profile_service_pb2.ListWebAuthnProfilesForSubjectRequest,
        context: _ServicerContext,
    ) -> typing.Union[yandex.cloud.priv.iam.v1.mfa.webauthn_profile_service_pb2.ListWebAuthnProfilesResponse, collections.abc.Awaitable[yandex.cloud.priv.iam.v1.mfa.webauthn_profile_service_pb2.ListWebAuthnProfilesResponse]]:
        """Returns the WebAuthn profile for the specified user.
        This method requires `iam.webAuthnProfiles.manage` permission.
        """

    @abc.abstractmethod
    def DeleteForSubject(
        self,
        request: yandex.cloud.priv.iam.v1.mfa.webauthn_profile_service_pb2.DeleteWebAuthnProfileForSubjectRequest,
        context: _ServicerContext,
    ) -> typing.Union[yandex.cloud.priv.operation.operation_pb2.Operation, collections.abc.Awaitable[yandex.cloud.priv.operation.operation_pb2.Operation]]:
        """Deletes the webAuthnProfiles profile for the specified user.
        This method requires `iam.webAuthnProfiles.manage` permission.
        """

    @abc.abstractmethod
    def ListOperations(
        self,
        request: yandex.cloud.priv.iam.v1.mfa.webauthn_profile_service_pb2.ListWebAuthnProfileOperationsRequest,
        context: _ServicerContext,
    ) -> typing.Union[yandex.cloud.priv.iam.v1.mfa.webauthn_profile_service_pb2.ListWebAuthnProfileOperationsResponse, collections.abc.Awaitable[yandex.cloud.priv.iam.v1.mfa.webauthn_profile_service_pb2.ListWebAuthnProfileOperationsResponse]]:
        """Retrieves the list of subject's operations."""

def add_WebAuthnProfileServiceServicer_to_server(servicer: WebAuthnProfileServiceServicer, server: typing.Union[grpc.Server, grpc.aio.Server]) -> None: ...
