"""
@generated by mypy-protobuf.  Do not edit manually!
isort:skip_file
"""

import builtins
import google.protobuf.descriptor
import google.protobuf.duration_pb2
import google.protobuf.internal.enum_type_wrapper
import google.protobuf.message
import google.protobuf.timestamp_pb2
import sys
import typing

if sys.version_info >= (3, 10):
    import typing as typing_extensions
else:
    import typing_extensions

DESCRIPTOR: google.protobuf.descriptor.FileDescriptor

class _BindingType:
    ValueType = typing.NewType("ValueType", builtins.int)
    V: typing_extensions.TypeAlias = ValueType

class _BindingTypeEnumTypeWrapper(google.protobuf.internal.enum_type_wrapper._EnumTypeWrapper[_BindingType.ValueType], builtins.type):
    DESCRIPTOR: google.protobuf.descriptor.EnumDescriptor
    BINDING_TYPE_UNSPECIFIED: _BindingType.ValueType  # 0
    """Invalid"""
    POST: _BindingType.ValueType  # 1
    """HTTP POST binding."""
    REDIRECT: _BindingType.ValueType  # 2
    """HTTP redirect binding."""
    ARTIFACT: _BindingType.ValueType  # 3
    """HTTP artifact binding."""

class BindingType(_BindingType, metaclass=_BindingTypeEnumTypeWrapper):
    """SAML Binding is a mapping of a SAML protocol message onto standard messaging formats and/or communications protocols."""

BINDING_TYPE_UNSPECIFIED: BindingType.ValueType  # 0
"""Invalid"""
POST: BindingType.ValueType  # 1
"""HTTP POST binding."""
REDIRECT: BindingType.ValueType  # 2
"""HTTP redirect binding."""
ARTIFACT: BindingType.ValueType  # 3
"""HTTP artifact binding."""
global___BindingType = BindingType

@typing.final
class Federation(google.protobuf.message.Message):
    """A federation resource.
    For more information, see [federations](/docs/iam/concepts/users/saml-federations).
    """

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    ID_FIELD_NUMBER: builtins.int
    FOLDER_ID_FIELD_NUMBER: builtins.int
    NAME_FIELD_NUMBER: builtins.int
    DESCRIPTION_FIELD_NUMBER: builtins.int
    CREATED_AT_FIELD_NUMBER: builtins.int
    COOKIE_MAX_AGE_FIELD_NUMBER: builtins.int
    AUTO_CREATE_ACCOUNT_ON_LOGIN_FIELD_NUMBER: builtins.int
    ISSUER_FIELD_NUMBER: builtins.int
    SSO_BINDING_FIELD_NUMBER: builtins.int
    SSO_URL_FIELD_NUMBER: builtins.int
    SECURITY_SETTINGS_FIELD_NUMBER: builtins.int
    CASE_INSENSITIVE_NAME_IDS_FIELD_NUMBER: builtins.int
    id: builtins.str
    """ID of the federation."""
    folder_id: builtins.str
    """ID of the folder that the federation belongs to."""
    name: builtins.str
    """Name of the federation.
    The name is unique within the cloud. 3-63 characters long.
    """
    description: builtins.str
    """Description of the federation. 0-256 characters long."""
    auto_create_account_on_login: builtins.bool
    """Auto create accounts for new user on first login."""
    issuer: builtins.str
    """federation issuer (entity Id)."""
    sso_binding: global___BindingType.ValueType
    """Single sign on endpoint binding type."""
    sso_url: builtins.str
    """Single sign on endpoint URL."""
    case_insensitive_name_ids: builtins.bool
    """Use case insensitive Name IDs."""
    @property
    def created_at(self) -> google.protobuf.timestamp_pb2.Timestamp:
        """Creation timestamp."""

    @property
    def cookie_max_age(self) -> google.protobuf.duration_pb2.Duration:
        """The 'IAM_COOKIE' cookie max age in seconds.
        The value should be in range from 10 min to 12 hours.
        The default value is 8 hours.
        """

    @property
    def security_settings(self) -> global___FederationSecuritySettings:
        """Federation security settings."""

    def __init__(
        self,
        *,
        id: builtins.str = ...,
        folder_id: builtins.str = ...,
        name: builtins.str = ...,
        description: builtins.str = ...,
        created_at: google.protobuf.timestamp_pb2.Timestamp | None = ...,
        cookie_max_age: google.protobuf.duration_pb2.Duration | None = ...,
        auto_create_account_on_login: builtins.bool = ...,
        issuer: builtins.str = ...,
        sso_binding: global___BindingType.ValueType = ...,
        sso_url: builtins.str = ...,
        security_settings: global___FederationSecuritySettings | None = ...,
        case_insensitive_name_ids: builtins.bool = ...,
    ) -> None: ...
    def HasField(self, field_name: typing.Literal["cookie_max_age", b"cookie_max_age", "created_at", b"created_at", "security_settings", b"security_settings"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing.Literal["auto_create_account_on_login", b"auto_create_account_on_login", "case_insensitive_name_ids", b"case_insensitive_name_ids", "cookie_max_age", b"cookie_max_age", "created_at", b"created_at", "description", b"description", "folder_id", b"folder_id", "id", b"id", "issuer", b"issuer", "name", b"name", "security_settings", b"security_settings", "sso_binding", b"sso_binding", "sso_url", b"sso_url"]) -> None: ...

global___Federation = Federation

@typing.final
class FederationSecuritySettings(google.protobuf.message.Message):
    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    ENCRYPTED_ASSERTIONS_FIELD_NUMBER: builtins.int
    encrypted_assertions: builtins.bool
    """Enable encrypted assertions."""
    def __init__(
        self,
        *,
        encrypted_assertions: builtins.bool = ...,
    ) -> None: ...
    def ClearField(self, field_name: typing.Literal["encrypted_assertions", b"encrypted_assertions"]) -> None: ...

global___FederationSecuritySettings = FederationSecuritySettings

@typing.final
class ServiceProviderCertificate(google.protobuf.message.Message):
    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    FEDERATION_ID_FIELD_NUMBER: builtins.int
    DATA_FIELD_NUMBER: builtins.int
    FINGERPRINT_FIELD_NUMBER: builtins.int
    NOT_AFTER_FIELD_NUMBER: builtins.int
    NOT_BEFORE_FIELD_NUMBER: builtins.int
    federation_id: builtins.str
    """ID of the federation that the certificate belongs to."""
    data: builtins.str
    """Certificate data in PEM format."""
    fingerprint: builtins.str
    """SHA256-fingerprint of the certificate."""
    @property
    def not_after(self) -> google.protobuf.timestamp_pb2.Timestamp:
        """Time after which the certificate is not valid."""

    @property
    def not_before(self) -> google.protobuf.timestamp_pb2.Timestamp:
        """Time before which the certificate is not valid."""

    def __init__(
        self,
        *,
        federation_id: builtins.str = ...,
        data: builtins.str = ...,
        fingerprint: builtins.str = ...,
        not_after: google.protobuf.timestamp_pb2.Timestamp | None = ...,
        not_before: google.protobuf.timestamp_pb2.Timestamp | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing.Literal["not_after", b"not_after", "not_before", b"not_before"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing.Literal["data", b"data", "federation_id", b"federation_id", "fingerprint", b"fingerprint", "not_after", b"not_after", "not_before", b"not_before"]) -> None: ...

global___ServiceProviderCertificate = ServiceProviderCertificate
